
#
# File: GetYesNo.sh
#
# Copyright 1995, by Hewlett-Packard Company
#
# The code in this file is from the book "Shell Programming
# Examples" by Bruce Blinn, published by Prentice Hall.
# This file may be copied free of charge for personal,
# non-commercial use provided that this notice appears in
# all copies of the file.  There is no warranty, either
# expressed or implied, supplied with this code.
#
# ̃t@C̃R[hBruce BlinnAPrentice Halls
# uShell Programming ExamplesvɌfڂĂ̂łB
# ̃t@ĆAlƂĉcړIƂpA
# ŕĂ܂܂B̏ꍇÂׂĂ
# ̐܂܂ĂKv܂B̃R[h
# ւẮAIɂÖٓIɂȂۏ؂s܂B
#

GetYesNo() {
     #
     # 
     #    GetYesNo - oɑ΂ Yes  No ̉擾
     #
     # 
     #    GetYesNo "message"
     #
     # 
     #    郁bZ[Wo͂Aɑ΂ẲƂ
     #    Yes  No v֐B
     #    Yes ꂽ^iOjԂA
     #    No ł΋UiPjԂ
     #    Yes ł No łȂꍇɂ͂ǂ͂悤
     #    ɗvBKǂ炩̓͂ȂƏIȂB
     #
     _ANSWER=            # [U͂鉞ϐ

     if [ $# -eq 0 ]; then
          echo "Usage: GetYesNo message" 1>&2
          exit 1
     fi

     while :
     do
          if [ "`echo -n`" = "-n" ]; then
               echo "$@\c"
          else
               echo -n "$@"
          fi
          read _ANSWER
          case "$_ANSWER" in
               [yY] | yes | YES | Yes ) return 0       ;;
               [nN] | no  | NO  | No  ) return 1       ;;
               * ) echo "Please enter y or n."         ;;
          esac
     done
}
