
#
# File: IsNewer.sh
#
# Copyright 1995, by Hewlett-Packard Company
#
# The code in this file is from the book "Shell Programming
# Examples" by Bruce Blinn, published by Prentice Hall.
# This file may be copied free of charge for personal,
# non-commercial use provided that this notice appears in
# all copies of the file.  There is no warranty, either
# expressed or implied, supplied with this code.
#
# ̃t@C̃R[hBruce BlinnAPrentice Halls
# uShell Programming ExamplesvɌfڂĂ̂łB
# ̃t@ĆAlƂĉcړIƂpA
# ŕĂ܂܂B̏ꍇÂׂĂ
# ̐܂܂ĂKv܂B̃R[h
# ւẮAIɂÖٓIɂȂۏ؂s܂B
#

IsNewer() {
     #
     # 
     #    IsNewer - 2̃t@C̓tׂ
     #
     # 
     #    IsNewer file1 file2
     #
     # 
     #    file2 ̓t file1 ̓t̕Viŋ߂̂́j
     #    Ȃΐ^iOjԂAłȂ΋UiPjԂ֐B
     #    tƂ̂͂̃t@C̍ŏIXVB
     #    
     if [ $# -ne 2 ]; then
          echo "Usage: IsNewer file1 file2" 1>&2
          exit 1
     fi

     if [ ! -f $1 -o ! -f $2 ]; then
          return 1       # w肳ꂽ̂t@CłȂꍇ
     fi

     if [ -n "`find $1 -newer $2 -print`" ]; then
          return 0       # V
     else
          return 1       # VȂ
     fi
}
