
#
# File: Question.sh
#
# Copyright 1995, by Hewlett-Packard Company
#
# The code in this file is from the book "Shell Programming
# Examples" by Bruce Blinn, published by Prentice Hall.
# This file may be copied free of charge for personal,
# non-commercial use provided that this notice appears in
# all copies of the file.  There is no warranty, either
# expressed or implied, supplied with this code.
#
# ̃t@C̃R[hBruce BlinnAPrentice Halls
# uShell Programming ExamplesvɌfڂĂ̂łB
# ̃t@ĆAlƂĉcړIƂpA
# ŕĂ܂܂B̏ꍇÂׂĂ
# ̐܂܂ĂKv܂B̃R[h
# ւẮAIɂÖٓIɂȂۏ؂s܂B
#

Question() {
     #
     # 
     #    Question - v
     #
     # 
     #    Question question default helpmessage
     #
     # 
     #    w肵bZ[WWo͂ɏoA
     #    [Uɉv֐B
     #    [U̓͂ʂ ANSWER ƂϐɑB
     #
     #    [U͊{Iɂǂ͂Ă悢
     #    iꉞA[U̓͂ yes  no ̏ꍇ͍lĂjB
     #    ͂ꂽɑ΂Ă̏̎s
     #    ϐ ANSWER ̒l𔻒fĊeVFXNvgōsB
     #    
     #    ͍ڂɃftHglݒ\B
     #    ̒lݒ肵ĂƁA₢킹bZ[ŴƂ
     #    [ ]ŊĂo͂B
     #    [U͋G^ł̃ftHgl͂ƂɂȂB
     #
     #    wvbZ[Ww\B
     #    [U͎ ? ƃ^Cv΁A
     #    ₤Ă̂A΂ǂ̂Ƃ
     #    bZ[W\łB
     #    wvbZ[Wo͌AēxvbZ[Wo͂B
     #
     #    ftHg̉ƃwvbZ[ẂAݒ肵Ȃꍇɂ
     #    "" Ƃ̕Ɏw肵ȂĂ͂ȂȂB
     #
     #    [U͉͎ q ƃ^Cv邱Ƃ
     #    VFXNvgI邱Ƃ\B
     #
     #    ͎ɁA! tĕʂ̃R}hs\B
     #    R}hsʂmFĂ͂ł悤ɂ́B
     #    R}h̎sAēxvbZ[Wo͂B
     #
     #    fobO[hpӂĂB
     #    ͎ -xA+x ŃfobO[h̃IIt؂ւB
     #
     if [ $# -lt 3 ]; then
          echo "Usage: Question question" \
               "default helpmessage" 1>&2
          exit 1
     fi
     ANSWER=             # [U̓̓f[^ϐ
     _DEFAULT=$2         # ftHg̒lZbg
     _QUESTION=          # ͗vbZ[Wϐ
     _HELPMSG=$3         # wvbZ[Wϐ

     if [ "$_DEFAULT" = "" ]; then
          _QUESTION="$1? "
     else
          _QUESTION="$1 [$_DEFAULT]? "
     fi

     while :
     do
          if [ "`echo -n`" = "-n" ]; then
               echo "$_QUESTION\c"
          else
               echo -n "$_QUESTION"
          fi
          read ANSWER
          case `echo "$ANSWER" | tr [A-Z] [a-z]` in
               "" ) if [ "$_DEFAULT" != "" ]; then
                         ANSWER=$_DEFAULT
                         break
                    fi
                    ;;

          yes | y ) ANSWER=yes
                    break
                    ;;

           no | n ) ANSWER=no
                    break
                    ;;

         quit | q ) exit 1
                    ;;

          +x | -x ) set $ANSWER
                    ;;

               !* ) eval `expr "$ANSWER" : "!\(.*\)"`
                    ;;

              "?" ) echo ""
                    if [ "$_HELPMSG" = "" ]; then
                         echo "No help available."
                    else
                         echo "$_HELPMSG"
                    fi
                    echo ""
                    ;;

               * )  break
                    ;;
          esac
     done
}
