
#
# t@C: CheckHostname.sh
#
# Copyright 1995, by Hewlett-Packard Company
#
# The code in this file is from the book "Shell Programming
# Examples" by Bruce Blinn, published by Prentice Hall.
# This file may be copied free of charge for personal,
# non-commercial use provided that this notice appears in
# all copies of the file.  There is no warranty, either
# expressed or implied, supplied with this code.
#
# ̃t@C̃R[hBruce BlinnAPrentice Halls
# uShell Programming ExamplesvɌfڂĂ̂łB
# ̃t@ĆAlƂĉcړIƂpA
# ŕĂ܂܂B̏ꍇÂׂĂ
# ̐܂܂ĂKv܂B̃R[h
# ւẮAIɂÖٓIɂȂۏ؂s܂B
#

CheckHostname() {
     #
     # 
     #    CheckHostname - zXg݂邩ǂ𔻒肷
     #
     # 
     #    CheckHostname [hostname]
     #
     # 
     #    w肵zXg݂ΐ^iOjԂA
     #    łȂ΋UiPjԂB
     #    zXĝw肵ĂȂꍇA
     #    ݎgp̃zXĝ`FbNB
     #
     _PING=                   # ping R}hg
     _HOST=${1:-`hostname`}   # `FbNzXg

     case `uname -s` in
          FreeBSD ) _PING="ping -c1 $_HOST"  ;; # FreeBSD
          Linux )   _PING="ping -c1 $_HOST"  ;; # Linux
          OSF1 )    _PING="ping -c1 $_HOST"  ;; # DEC OSF
          HP-UX )   _PING="ping $_HOST 64 1" ;; # HP-UX
          IRIX )    _PING="ping -c1 $_HOST"  ;; # SGI
          SunOS )   _PING="ping $_HOST"      ;; # BSD and
                                                # Solaris
          * )       return 1                 ;;
     esac

     if [ `$_PING 2>&1 | grep -ci "Unknown host"` -eq 0 ]
     then
          return 0
     else
          return 1
     fi
}
