
#
# File: FullName.sh
#
# Copyright 1995, by Hewlett-Packard Company
#
# The code in this file is from the book "Shell Programming
# Examples" by Bruce Blinn, published by Prentice Hall.
# This file may be copied free of charge for personal,
# non-commercial use provided that this notice appears in
# all copies of the file.  There is no warranty, either
# expressed or implied, supplied with this code.
#
# ̃t@C̃R[hBruce BlinnAPrentice Halls
# uShell Programming ExamplesvɌfڂĂ̂łB
# ̃t@ĆAlƂĉcړIƂpA
# ŕĂ܂܂B̏ꍇÂׂĂ
# ̐܂܂ĂKv܂B̃R[h
# ւẮAIɂÖٓIɂȂۏ؂s܂B
#

FullName() {
     #
     # 
     #    FullName - t@CfBNg̊SpXԂ
     #
     # 
     #    FullName filename | directory
     #
     # 
     #    w肳ꂽt@CfBNgSpX
     #    \̂Ԃ֐B 
     #    SpXƂ / Ŏn܂t@CfBNg̖̕\̂ƁB
     #    ʂ͕Wo͂ɕ\B
     #    w肵t@CfBNg݂ȂA
     #    ̂܂܉ɂƂ̖O\B
     #    
     _CWD=`pwd`          # ݂̍ƃfBNgo

     if [ $# -ne 1 ]; then
          echo "Usage: FullName filename | directory" 1>&2
          exit 1
     fi

     if [ -d $1 ]; then
          cd $1
          echo `pwd`
     elif [ -f $1 ]; then
          cd `dirname $1`
          echo `pwd`/`basename $1`
     else
          echo $1
     fi

     cd $_CWD            # Ƃ̍ƃfBNgɖ߂
}
