
#
# File: IsSystemType.sh
#
# Copyright 1995, by Hewlett-Packard Company
#
# The code in this file is from the book "Shell Programming
# Examples" by Bruce Blinn, published by Prentice Hall.
# This file may be copied free of charge for personal,
# non-commercial use provided that this notice appears in
# all copies of the file.  There is no warranty, either
# expressed or implied, supplied with this code.
#
# ̃t@C̃R[hBruce BlinnAPrentice Halls
# uShell Programming ExamplesvɌfڂĂ̂łB
# ̃t@ĆAlƂĉcړIƂpA
# ŕĂ܂܂B̏ꍇÂׂĂ
# ̐܂܂ĂKv܂B̃R[h
# ւẮAIɂÖٓIɂȂۏ؂s܂B
#

IsSystemType() {
     #
     # 
     #    IsSystemType - VXẽ^Cvǂ𔻒肷
     #
     # 
     #    IsSystemType string
     #
     # 
     #    w肵񂪍삵ĂVXe\킷̂ǂ
     #    𒲂ׂ֐Buname R}hgă`FbNA
     #    Ăΐ^iOjԂĂȂ΋UiPjԂB
     #
     if [ $# -ne 1 ]; then
          echo "Usage: IsSystemType string" 1>&2
          exit 1
     fi

     if [ "$1" = "`uname -s`" ]; then
          return 0
     elif [ "$1" = "`uname -m`" ]; then
          return 0
     else
          case `uname -r` in
               "$1"* ) return 0 ;;
          esac
     fi
     return 1
}
