
#
# File: SystemType.sh
#
# Copyright 1995, by Hewlett-Packard Company
#
# The code in this file is from the book "Shell Programming
# Examples" by Bruce Blinn, published by Prentice Hall.
# This file may be copied free of charge for personal,
# non-commercial use provided that this notice appears in
# all copies of the file.  There is no warranty, either
# expressed or implied, supplied with this code.
#
# ̃t@C̃R[hBruce BlinnAPrentice Halls
# uShell Programming ExamplesvɌfڂĂ̂łB
# ̃t@ĆAlƂĉcړIƂpA
# ŕĂ܂܂B̏ꍇÂׂĂ
# ̐܂܂ĂKv܂B̃R[h
# ւẮAIɂÖٓIɂȂۏ؂s܂B
#

SystemType() {
     #
     # 
     #    SystemType - ̃VXe𔻒f閼̂o͂
     #
     # 
     #    SystemType
     #
     # 
     #    ̊֐̓VXẽ^Cv𔻕ʂAȉ
     #    ꂩ̕ԂB
     #    
     #         FREEBSD   LINUX     AIX       DECOSF    HP
     #         SCO       SGI       SOLARIS   SUNBSD    ULTRIX
     #
     #    ULTRIX  DEC ̌Â^Cv BSD ñVXełA
     #    DECOSF  OSF x[Xɂ DEC ̃VXeB
     #
     #    SUNBSD  SUN  BSD n̂́io[W 4.xxjłA
     #    SOLARIS  SUN  System V nio[W 5.xxjB
     #
     #    VXeʂłȂꍇɂ̓kԂB
     #
     _HOSTNAME=`hostname | sed 's/\..*//'`

     case `uname -s` in
          FreeBSD )      echo FREEBSD             ;;
          Linux )        echo LINUX               ;;
          AIX )          echo AIX                 ;;
          HP-UX )        echo HP                  ;;
          IRIX )         echo SGI                 ;;
          OSF1 )         echo DECOSF              ;;
          ULTRIX )       echo ULTRIX              ;;
          SunOS )        case `uname -r` in
                              4*)  echo SUNBSD    ;;
                              5*)  echo SOLARIS   ;;
                         esac
                         ;;
          $_HOSTNAME )   case `uname -m` in
                              IP*)      echo SGI  ;;
                              i386)     echo SCO  ;;
                         esac
                         ;;
     esac
}
